﻿Module Module1

    ' Ein paar Körper

    Class Sphere
        Public m As Vector3
        Public r As Double

        Public Function Contains(ByVal x As Vector3) As Boolean
            Return (x - m).Length <= r
        End Function
    End Class

    Class Plane
        Private p As Vector3
        Private n As Vector3

        Public Sub New(ByVal a As Vector3, ByVal b As Vector3, ByVal c As Vector3)
            p = a
            n = Vector3.Cross(b - a, c - a).Normalize
        End Sub

        Public Function Distance(ByVal x As Vector3) As Double
            Return Math.Abs((x - p) * n)
        End Function
    End Class

    Sub Main()

        ' Vektorrechnung: 2D
        Dim a As New Vector2(3, 1)
        Dim b As New Vector2(-4, 0)

        Dim O As Vector2

        Console.WriteLine(3 * (2 * a + b - O) / 4)

        ' Vektorrechnung: 3D
        Dim x As New Vector3(-6, 0, 21)
        x *= 2
        x -= New Vector3(-5, 2, 0)
        Console.WriteLine("|{0}| = {1}", x, x.Length)

        Dim Sphere = New Sphere With {.m = New Vector3(-6, 3, 3), .r = 50}
        Console.WriteLine("x in der Kugel enthalten? {0}", Sphere.Contains(x))

        Dim y As New Vector3(4, 6, -1)
        Dim Plane = New Plane(New Vector3(-1, -1, -1), New Vector3(11, -1, 3), New Vector3(0, -1, 2))
        Console.WriteLine("Abstand von {0} zur Ebene: {1}", y, Plane.Distance(y))

        Console.ReadKey()
    End Sub

End Module
